import json
import os
import time
from math import floor
from unitypack.asset import Asset, ObjectPointer, FFOrderedDict, ObjectInfo

start = time.time()

APPDATA_IN =  (os.path.expandvars('%userprofile%')) + '/AppData/LocalLow/Unity/Web Player/Cache/FusionFallA/'
APPDATA_OUT =  (os.path.expandvars('%userprofile%')) + '/AppData/LocalLow/Unity/Web Player/Cache/FusionFall/'

TABLEDATA_IN = APPDATA_IN + 'tabledata_2eresourceFile/CustomAssetBundle-TableData'
ICONS_IN = APPDATA_IN + 'icons_2eresourceFile/CustomAssetBundle-Icons'

TABLEDATA_TARGET = APPDATA_OUT + 'tabledata_2eresourceFile/CustomAssetBundle-1dca92eecee4742d985b799d8226666d_old'
SHARED_TARGET = APPDATA_OUT + 'retro_5fshared_2eresourceFile/CustomAssetBundle-Retro_shared_old'
MESH_TARGET = APPDATA_OUT + 'characterselection_2eresourceFile/CustomAssetBundle-ce09c4c9be8a046ca92e0044f22d1b99'

serverxdt = json.loads(open('D:/Fusion/OpenFusion/tdata/xdt_old.json', 'r').read())

tmp = open(TABLEDATA_IN, 'rb')
tabledata = Asset.from_file(tmp)

tmp = open(ICONS_IN, 'rb')
icons = Asset.from_file(tmp)
iconsContainer = icons.objects[1].contents['m_Container']

tmp = open(TABLEDATA_TARGET, 'rb')
newtabledata = Asset.from_file(tmp)

tmp = open(SHARED_TARGET, 'rb')
newshared = Asset.from_file(tmp)
newPreloadTable = newshared.objects[1].contents['m_PreloadTable']
newContainer = newshared.objects[1].contents['m_Container']

# print(newContainer[643])
# pstart = newContainer[643][1]['preloadIndex']
# psize = newContainer[643][1]['preloadSize']
# for p in newPreloadTable[pstart : pstart + psize]:
	
# 	if p.object.class_id == 115: 
# 		print(p.file_id, p.path_id, p.object.type_id, p.object.class_id, p.object, p.object.asset.name)
# 		print(p.resolve())
# 	try:
# 		print(p.object.contents._obj)
# 	except:
# 		print(p.object.contents)

# print(newshared.pretty())

TYPE_LIST = ['Weapon', 'Shirts', 'Pants', 'Shoes', 'Hat', 'Glass', 'Back']

# for i in range(7):
# 	#itemTable = tabledata.objects[2139558964].contents[f'm_p{TYPE_LIST[i]}ItemTable']
# 	itemTable = newtabledata.objects[7].contents[f'm_p{TYPE_LIST[i]}ItemTable']
# 	for j in range(len(itemTable['m_pItemData'])):
# 		item = itemTable['m_pItemData'][j]
# 		print(i, j, itemTable['m_pItemStringData'][item['m_iItemName']]['m_strName'])
# 	print()

# for string in tabledata.objects[2139558964].contents[f'm_p{TYPE_LIST[6]}ItemTable']['m_pItemStringData']:
# 	print(string['m_strName'])

def replace(obj, pathMap):
	className = obj.__class__.__name__
	if className == 'GameObject':
		for key, value in obj._obj.items(): obj._obj[key] = replace(value, pathMap)
		return obj
	elif className == 'ObjectPointer':
		if obj.object.type_id == 115:
			ret = ObjectPointer(None, newshared)
			ret.file_id = 4
			if obj.object.contents['m_Name'] == 'ActorWearSkinTable':
				ret.path_id = 36269
			else:
				ret.path_id = 36270
			return ret
		if obj.source_asset != newshared:
			ret = ObjectPointer(None, newshared)
			ret.file_id = 0
			ret.path_id = pathMap[obj.path_id]
			return ret
		return obj
	elif className == 'Transform' or className == 'Animation' or className == 'AnimationClip' or className == 'MeshFilter' or className == 'Mesh' or className == 'Material' or className == 'Texture2D' or className == 'SubMesh' or className == 'Renderer' or className == 'Shader':
		for key, value in obj._obj.items(): obj._obj[key] = replace(value, pathMap)
		return obj
	elif className == 'FFOrderedDict':
		for key, value in obj.items(): obj[key] = replace(value, pathMap)
		return obj
	elif className == 'bytes': return obj
	elif className == 'str' or className == 'int' or className == 'float' or className == 'bool': return obj
	elif className == 'list':
		ret = [0] * len(obj)
		for i in range(len(obj)): ret[i] = replace(obj[i], pathMap)
		return ret
	elif className == 'tuple':
		ret = [0] * len(obj)
		for i in range(len(obj)): ret[i] = replace(obj[i], pathMap)
		return tuple(ret)
	elif className == 'NoneType': return obj
	else:
		print(f'Unhandled {className} {obj}')

def addItem(itemType, itemId):
	typeString = TYPE_LIST[itemType]

	tmp1 = open(APPDATA_IN + f'charactertexture/CustomAssetBundle-Character_Texture_{typeString.lower()}', 'rb')
	textures = Asset.from_file(tmp1)
	texturesPreloadTable = textures.objects[1].contents['m_PreloadTable']
	texturesContainer = textures.objects[1].contents['m_Container']

	tmp2 = open(APPDATA_IN + f'characterselectionwear/CustomAssetBundle-CharacterSelection_wear_{typeString.lower()}', 'rb')
	meshes = Asset.from_file(tmp2)
	meshesPreloadTable = meshes.objects[1].contents['m_PreloadTable']
	meshesContainer = meshes.objects[1].contents['m_Container']

	itemTable = tabledata.objects[2139558964].contents[f'm_p{typeString}ItemTable']
	newItemTable = newtabledata.objects[7].contents[f'm_p{typeString}ItemTable']

	''' Item Data '''

	newItemId = len(newItemTable['m_pItemData'])
	itemData = itemTable['m_pItemData'][itemId]
	itemString = itemTable['m_pItemStringData'][itemId]
	itemIcon = itemTable['m_pItemIconData'][itemData['m_iIcon']]
	itemMesh = itemTable['m_pItemMeshData'][itemData['m_iMesh']]

	itemData['m_iItemNumber'] = newItemId
	itemData['m_iItemName'] = len(newItemTable['m_pItemStringData'])
	itemData['m_iComment'] = len(newItemTable['m_pItemStringData'])

	''' Icon Data '''

	iconType = itemIcon['m_iIconType']
	iconNum = itemIcon['m_iIconNumber']
	iconPath = f'icons/cosicon_{iconNum:02d}.png'
	nextIconNumber = 0
	if iconType == 0: 
		iconPath = f'icons/wpnicon_{iconNum:02d}.png'
		nextIconNumber = newItemTable['m_pItemIconData'][-1]['m_iIconNumber'] + 1
	else:
		for pair in newContainer:
			if 'icons/cosicon' in pair[0]:
				num = int(pair[0].split('_')[1].split('.')[0])
				if num > nextIconNumber: nextIconNumber = num
		nextIconNumber += 1

	iconObject = None
	for entry in iconsContainer:
		if entry[0] == iconPath: 
			iconObject = entry[1]['asset'].object
			break
	assert iconObject != None

	iconEntry = FFOrderedDict()
	iconEntry['m_iIconNumber'] = nextIconNumber
	iconEntry['m_iIconType'] = iconType

	nextIconId = len(newItemTable['m_pItemIconData'])
	itemData['m_iIcon'] = nextIconId
	newItemTable['m_pItemIconData'].append(iconEntry)

	newIconObject = newshared.add_object(iconObject.type_id)
	newIconObject._contents = iconObject.contents
	nextPathId = newIconObject.path_id

	newIconPath = f'icons/cosicon_{nextIconNumber:02d}.png'
	if iconType == 0: newIconPath = f'icons/wpnicon_{nextIconNumber:02d}.png'

	iconContainerEntry = (newIconPath, FFOrderedDict())
	iconContainerEntry[1]['preloadIndex'] = len(newPreloadTable)
	iconContainerEntry[1]['preloadSize'] = 1
	iconContainerEntry[1]['asset'] = ObjectPointer(None, newshared)
	iconContainerEntry[1]['asset'].file_id = 0
	iconContainerEntry[1]['asset'].path_id = nextPathId
	newContainer.append(iconContainerEntry)

	newPreloadTable.append(ObjectPointer(None, newshared))
	newPreloadTable[-1].file_id = 0
	newPreloadTable[-1].path_id = nextPathId

	''' Mesh data '''

	textureName = itemMesh['m_pstrMTextureString'].lower()
	texturePath = f'texture/{textureName}.dds'

	textureObject = None
	for entry in texturesContainer:
		if entry[0] == texturePath:
			textureObject = entry[1]['asset'].object
			break
	if textureObject == None:
		print("Texture path not found: ", texturePath)
	else:
		newTextureObject = newshared.add_object(textureObject.type_id)
		newTextureObject._contents = textureObject.contents
		nextPathId = newTextureObject.path_id

		textureContainerEntry = (texturePath, FFOrderedDict())
		textureContainerEntry[1]['preloadIndex'] = len(newPreloadTable)
		textureContainerEntry[1]['preloadSize'] = 1
		textureContainerEntry[1]['asset'] = ObjectPointer(None, newshared)
		textureContainerEntry[1]['asset'].file_id = 0
		textureContainerEntry[1]['asset'].path_id = nextPathId
		newContainer.append(textureContainerEntry)

		newPreloadTable.append(ObjectPointer(None, newshared))
		newPreloadTable[-1].file_id = 0
		newPreloadTable[-1].path_id = nextPathId

	meshName = itemMesh['m_pstrMMeshModelString'].lower()
	meshPath = f'wear/{meshName}.nif'

	meshEntry = None
	for entry in meshesContainer:
		if entry[0] == meshPath:
			meshEntry = entry
			break
	assert meshEntry != None

	preloadStart = meshEntry[1]['preloadIndex']
	preloadCount = meshEntry[1]['preloadSize']

	nextObjectIndex = newshared.next_path_id()
	pathMap = {}

	meshContainerEntry = (meshPath, FFOrderedDict())
	meshContainerEntry[1]['preloadIndex'] = len(meshesPreloadTable)
	meshContainerEntry[1]['preloadSize'] = preloadCount

	skipped = 0

	for preload in meshesPreloadTable[preloadStart : preloadStart + preloadCount]:
		objectInfo = preload.object
		if objectInfo.type_id == 115: #Actorwearskintable
			newPreload = ObjectPointer(None, newshared)
			newPreload.file_id = 4
			if objectInfo.contents['m_Name'] == 'ActorWearSkinTable':
				newPreload.path_id = 36269
			else:
				newPreload.path_id = 36270
			newPreloadTable.append(newPreload)
			skipped += 1
		else:
			t = None
			if objectInfo.class_id == 114:
				if objectInfo.type == 'ActorWearSkinTable': t = -6
				if objectInfo.type == 'ActorWearIndexTable': t = -3
			newObject = newshared.add_object(objectInfo.class_id, t)
			newObject._contents = objectInfo.contents

			pathMap[preload.path_id] = newObject.path_id

			newPreload = ObjectPointer(None, newshared)
			newPreload.file_id = 0
			newPreload.path_id = newObject.path_id
			newPreloadTable.append(newPreload)

	meshContainerEntry[1]['asset'] = ObjectPointer(None, newshared)
	meshContainerEntry[1]['asset'].file_id = 0
	meshContainerEntry[1]['asset'].path_id = pathMap[meshEntry[1]['asset'].path_id]
	newContainer.append(meshContainerEntry)

	for i in range(nextObjectIndex, nextObjectIndex + preloadCount - skipped):
		newshared.objects[i]._contents = replace(newshared.objects[i].contents, pathMap)

	
	if itemMesh['m_pstrFMeshModelString'].lower() != itemMesh['m_pstrMMeshModelString'].lower():
		meshName = itemMesh['m_pstrFMeshModelString'].lower()
		meshPath = f'wear/{meshName}.nif'

		meshEntry = None
		for entry in meshesContainer:
			if entry[0] == meshPath:
				meshEntry = entry
				break
		assert meshEntry != None

		preloadStart = meshEntry[1]['preloadIndex']
		preloadCount = meshEntry[1]['preloadSize']

		nextObjectIndex = newshared.next_path_id()
		pathMap = {}

		meshContainerEntry = (meshPath, FFOrderedDict())
		meshContainerEntry[1]['preloadIndex'] = len(meshesPreloadTable)
		meshContainerEntry[1]['preloadSize'] = preloadCount

		skipped = 0

		for preload in meshesPreloadTable[preloadStart : preloadStart + preloadCount]:
			objectInfo = preload.object
			if objectInfo.type_id == 115: #Actorwearskintable
				newPreload = ObjectPointer(None, newshared)
				newPreload.file_id = 4
				if objectInfo.contents['m_Name'] == 'ActorWearSkinTable':
					newPreload.path_id = 36269
				else:
					newPreload.path_id = 36270
				newPreloadTable.append(newPreload)
				skipped += 1
			else:
				t = None
				if objectInfo.class_id == 114:
					if objectInfo.type == 'ActorWearSkinTable': t = -6
					if objectInfo.type == 'ActorWearIndexTable': t = -3
				newObject = newshared.add_object(objectInfo.class_id, t)
				newObject._contents = objectInfo.contents

				pathMap[preload.path_id] = newObject.path_id

				newPreload = ObjectPointer(None, newshared)
				newPreload.file_id = 0
				newPreload.path_id = newObject.path_id
				newPreloadTable.append(newPreload)

		meshContainerEntry[1]['asset'] = ObjectPointer(None, newshared)
		meshContainerEntry[1]['asset'].file_id = 0
		meshContainerEntry[1]['asset'].path_id = pathMap[meshEntry[1]['asset'].path_id]
		newContainer.append(meshContainerEntry)

		for i in range(nextObjectIndex, nextObjectIndex + preloadCount - skipped):
			newshared.objects[i]._contents = replace(newshared.objects[i].contents, pathMap)

	nextMeshId = len(newItemTable['m_pItemMeshData'])
	itemData['m_iMesh'] = nextMeshId
	newItemTable['m_pItemMeshData'].append(itemMesh)

	itemData['m_iCashAble'] = 0
	itemData['m_iTradeAble'] = 1
	itemData['m_iSellAble'] = 1
	del itemData['m_iStarterZoneEnabled']

	newItemTable['m_pItemData'].append(itemData)
	newItemTable['m_pItemStringData'].append(itemString)
	serverxdt[f'm_p{TYPE_LIST[itemType]}ItemTable'] = newItemTable

	tmp1.close()
	tmp2.close()
	print(itemString['m_strName'], itemType, newItemId)

addItem(0, 692) # Prov gun
addItem(1, 506) # Prov shirt
addItem(2, 488) # Prov pants
addItem(3, 495) # Prov boots
addItem(4, 197) # Prov helmet

addItem(4, 286) # TOM 2.0
addItem(4, 287) # TOM 4.0

addItem(1, 536) # Marceline shirt

addItem(0, 713) # Imaginary sorcerer staff
addItem(1, 624) # Imaginary sorcerer shirt
addItem(2, 530) # Imaginary sorcerer pants
addItem(3, 537) # Imaginary sorcerer shoes
addItem(4, 260) # Imaginary sorcerer hood

addItem(0, 699) # Biowulf claw
addItem(1, 513) # Biowulf shirt
addItem(2, 495) # Biowulf pants
addItem(3, 502) # Biowulf shoes
addItem(4, 212) # Biowulf head

addItem(6, 76) # Ultimate big chill wings

addItem(1, 509) # Finn shirt
addItem(2, 491) # Finn pants
addItem(3, 498) # Finn shoes
addItem(4, 203) # Finn head
addItem(6, 82) # Finn backpack

addItem(0, 693) # Agent six claw
addItem(1, 511) # Agent six shirt
addItem(2, 493) # Agent six pants
addItem(3, 500) # Agent six shoes
addItem(5, 64) # Agent six glasses

addItem(0, 700) # Nanite mace

addItem(6, 80) # Clockwork furnace

addItem(1, 512) # Rex shirt
addItem(2, 494) # Rex pants
addItem(3, 501) # Rex shoes
addItem(5, 63) # Rex goggles

addItem(1, 598) # Flibber flabber shirt
addItem(2, 506) # Flibber flabber pants
addItem(3, 513) # Flibber flabber shoes
addItem(4, 235) # Flibber flabber collar

addItem(1, 601) # Cannonbolt shirt
addItem(2, 509) # Cannonbolt pants
addItem(3, 516) # Cannonbolt shoes

addItem(1, 592) # Necrofriggian shirt
addItem(2, 500) # Necrofriggian pants
addItem(3, 507) # Necrofriggian shoes
addItem(4, 231) # Necrofriggian head
addItem(6, 87) # Necrofriggian backpack

addItem(6, 83) # Boogie pack
addItem(6, 70) # Chromastone shards

addItem(1, 619) # Flying Monkey yo
addItem(0, 612) # QA only

addItem(5, 66) # Owl guardian mask
addItem(6, 64) # Turkey tail

addItem(1, 641) # Benwolf shirt
addItem(2, 544) # Benwolf pants
addItem(3, 551) # Benwolf shoes
addItem(5, 70) # Ben wolf snout
addItem(6, 104) # Benwolf tail

addItem(1, 504) # Ship mechomorph shirt
addItem(2, 486) # Ship mechomorph pants
addItem(3, 493) # Ship mechomorph shoes
addItem(4, 193) # Ship mechomorph head

addItem(4, 255) # Modula hat
addItem(5, 72) # Evil goatee
addItem(5, 73) # General modula
addItem(5, 74) # Giant tongue
addItem(5, 75) # Glowing eyes
addItem(5, 78) # Leakey lake leech

addItem(1, 495) # Ultra rare prototype
addItem(2, 478)
addItem(3, 485)

newtabledata.objects[7].contents['m_pNpcTable']['m_pNpcData'][3266]['m_iHP'] = 300000

with open('D:/Fusion/OpenFusion/tdata/xdt.json', 'w') as f:
	json.dump(serverxdt, f, indent=4)

with open(TABLEDATA_TARGET[:-4], 'wb') as f:
	newtabledata.save(f)

with open(SHARED_TARGET[:-4], 'wb') as f:
	newshared.save(f)

print(f'Done. Time elapsed: {time.time() - start}s')