import os
import json
from unitypack.asset import Asset
from unitypack.object import FFOrderedDict

TABLEDATA_PATH = (os.path.expandvars('%userprofile%')) + '/AppData/LocalLow/Unity/Web Player/Cache/FusionFall/tabledata_2eresourceFile/CustomAssetBundle-1dca92eecee4742d985b799d8226666d_old'
XDTINDEX = 7

f = open(TABLEDATA_PATH, 'rb')
tabledata = Asset.from_file(f)

xdt = tabledata.objects[XDTINDEX].contents

serverfile = open('D:/Fusion/OpenFusion/tdata/xdt_old.json', 'r')
serverxdt = json.loads(serverfile.read())
serverfile.close()

def addWarp(name, x, y, z):
	stringEntry = FFOrderedDict()
	for k,v in xdt['m_pNpcTable']['m_pNpcStringData'][2130].items(): stringEntry[k] = v

	stringEntry['m_strName'] = name
	npcId = len(xdt['m_pNpcTable']['m_pNpcStringData'])
	xdt['m_pNpcTable']['m_pNpcStringData'].append(stringEntry)

	serverStringEntry = {}
	for k,v in stringEntry.items(): serverStringEntry[k] = v
	serverxdt['m_pNpcTable']['m_pNpcStringData'].append(serverStringEntry)


	npcEntry = FFOrderedDict()
	for k,v in xdt['m_pNpcTable']['m_pNpcData'][2130].items(): npcEntry[k] = v

	npcEntry['m_iNpcNumber'] = npcId
	npcEntry['m_iNpcName'] = npcId
	npcEntry['m_iComment'] = npcId
	xdt['m_pNpcTable']['m_pNpcData'].append(npcEntry)

	serverNpcEntry = {}
	for k,v in npcEntry.items(): serverNpcEntry[k] = v
	serverxdt['m_pNpcTable']['m_pNpcData'].append(serverNpcEntry)

	warpEntry = FFOrderedDict()
	for k,v in xdt['m_pInstanceTable']['m_pWarpData'][0].items(): warpEntry[k] = v

	warpEntry['m_iWarpNumber'] = len(xdt['m_pInstanceTable']['m_pWarpData'])
	warpEntry['m_iNpcNumber'] = npcId
	warpEntry['m_iToX'] = x
	warpEntry['m_iToY'] = y
	warpEntry['m_iToZ'] = z
	xdt['m_pInstanceTable']['m_pWarpData'].append(warpEntry)

	serverWarpEntry = {}
	for k, v in warpEntry.items(): serverWarpEntry[k] = v
	serverxdt['m_pInstanceTable']['m_pWarpData'].append(serverWarpEntry)
	print(npcId, name)

def addMob(template, name, level, hp, height, radius, scale, damage, defense, eruptionProb, skill, skillProb):
	stringEntry = FFOrderedDict()
	for k,v in xdt['m_pNpcTable']['m_pNpcStringData'][template].items(): stringEntry[k] = v

	stringEntry['m_strName'] = name
	npcId = len(xdt['m_pNpcTable']['m_pNpcStringData'])
	xdt['m_pNpcTable']['m_pNpcStringData'].append(stringEntry)

	serverStringEntry = {}
	for k,v in stringEntry.items(): serverStringEntry[k] = v
	serverxdt['m_pNpcTable']['m_pNpcStringData'].append(serverStringEntry)

	npcEntry = FFOrderedDict()
	for k,v in xdt['m_pNpcTable']['m_pNpcData'][template].items(): npcEntry[k] = v

	npcEntry['m_iNpcNumber'] = npcId
	npcEntry['m_iNpcName'] = npcId
	npcEntry['m_iComment'] = npcId
	npcEntry['m_iNpcLevel'] = level
	npcEntry['m_iHP'] = hp
	npcEntry['m_iDropType'] = 0
	npcEntry['m_iHeight'] = height
	npcEntry['m_iRadius'] = radius
	npcEntry['m_fScale'] = scale
	npcEntry['m_iPower'] = damage
	npcEntry['m_iProtection'] = defense
	npcEntry['m_iMegaTypeProb'] = eruptionProb
	npcEntry['m_iActiveSkill1'] = skill
	npcEntry['m_iActiveSkill1Prob'] = skillProb
	xdt['m_pNpcTable']['m_pNpcData'].append(npcEntry)

	serverNpcEntry = {}
	for k,v in npcEntry.items(): serverNpcEntry[k] = v
	serverxdt['m_pNpcTable']['m_pNpcData'].append(serverNpcEntry)
	print(npcId, name)

addWarp('Null Void', 19675, 109100, 8600)
addWarp('Megawatt Grounds', 17850, 126000, 8600)
addWarp('Main Area', 17008, 113373, 8600)
addWarp('Providence HQ', 18025, 157240, 500)
addWarp('Mt. Neverest', 29095, 242150, 6300)
addWarp('Townsville Park', 109925, 221450, -2500)
# Level, hp, height, radius, scale, damage, defense
# 111 damage 113 heal
addMob(632, 'Slag Dragon', 
	37, 6000, 480, 160, 1.5, 220, 600, 200000, 140, 200000) # Leech
addMob(2456, 'Alkaline Cephalopod', 
	37, 4500, 540, 160, 1.6, 240, 540, 200000, 170, 150000) # Drain
addMob(36, 'Hypercharged Megawatt', 
	37, 3200, 600, 100, 3.0, 420, 450, 100000, 114, 250000) # Stun

addMob(627, 'Swamp Simian', 
	38, 7000, 480, 120, 1.5, 260, 650, 250000, 110, 150000) # Heal
addMob(627, 'Swamp Reaper', 
	38, 9500, 640, 140, 2.0, 280, 650, 300000, 110, 150000) # Heal
addMob(2111, 'Enraged Fusionfly', 
	38, 8000, 540, 150, 1.2, 320, 540, 200000, 114, 250000) # Stun

addMob(3187, 'Stone Scorpion', 
	39, 15000, 300, 120, 1.5, 280, 750, 200000, 140, 300000) # Leech
addMob(3037, 'Tyrant Claw', 
	39, 10000, 120, 120, 1.2, 360, 700, 300000, 111, 300000) # Damage
addMob(3037, 'Tyrant Claw King', 
	39, 12500, 170, 120, 1.7, 400, 700, 300000, 111, 300000) # Damage

addMob(3182, 'Column Colossus', 
	40, 20000, 600, 120, 3.0, 420, 1000, 300000, 114, 600000) # Stun
addMob(3179, 'Injustice Foe', 
	40, 50000, 1200, 160, 6.0, 500, 2000, 300000, 110, 500000) # Heal

# print(len(xdt['m_pNpcTable']['m_pNpcData']))
# print(len(serverxdt['m_pNpcTable']['m_pNpcData']))
# print(len(xdt['m_pNpcTable']['m_pNpcStringData']))
# print(len(serverxdt['m_pNpcTable']['m_pNpcStringData']))
# print(len(xdt['m_pInstanceTable']['m_pWarpData']))
# print(len(serverxdt['m_pInstanceTable']['m_pWarpData']))
# print(xdt['m_pNpcTable']['m_pNpcData'][-1]['m_iNpcNumber'])

with open(TABLEDATA_PATH[:-4], 'wb') as f:
	tabledata.save(f)

with open('D:/Fusion/OpenFusion/tdata/xdt.json', 'w') as f:
	json.dump(serverxdt, f, indent=4)