# Registers a new map tile in tabledata for it to show up on the minimap and during character selection

import os
from unitypack.asset import Asset
from unitypack.object import FFOrderedDict

TABLEDATA_PATH = (os.path.expandvars('%userprofile%')) + '/AppData/LocalLow/Unity/Web Player/Cache/FusionFall/tabledata_2eresourceFile/CustomAssetBundle-1dca92eecee4742d985b799d8226666d_old'
XDTINDEX = 8

f = open(TABLEDATA_PATH, 'rb')
tabledata = Asset.from_file(f)

namedata = tabledata.objects[XDTINDEX].contents['m_pWorldNameData']

entry = FFOrderedDict()
area = FFOrderedDict()
area['x'] = 0.0
area['y'] = 1024.0
area['width'] = 512.0
area['height'] = 512.0
entry['Area'] = area
entry['DongName'] = 'Null Void'
entry['ZoneName'] = 'Training Grounds'
namedata.append(entry)

entry = FFOrderedDict()
area = FFOrderedDict()
area['x'] = 0.0
area['y'] = 1536.0
area['width'] = 512.0
area['height'] = 512.0
entry['Area'] = area
entry['DongName'] = 'Providence HQ'
entry['ZoneName'] = 'Training Grounds'
namedata.append(entry)

entry = FFOrderedDict()
area = FFOrderedDict()
area['x'] = 0.0
area['y'] = 2048.0
area['width'] = 512.0
area['height'] = 512.0
entry['Area'] = area
entry['DongName'] = 'Mt. Neverest'
entry['ZoneName'] = 'Training Grounds'
namedata.append(entry)

for n in namedata:
	print(n)

outfile = open(TABLEDATA_PATH[:-4], 'wb')
tabledata.save(outfile)