# List every asset from every bundle from FF cache. This produces around 8MB of text. 
# I ran this particularly for the Academy cache so I could quickly search an asset by name and find its index in the container (a method I used for backport.py)

import os
from unitypack.asset import Asset

APPDATA_PATH = (os.path.expandvars('%userprofile%')) + '/AppData/LocalLow/Unity/Web Player/Cache/FusionFall/'

for path in os.listdir(APPDATA_PATH):
	if os.path.isdir(APPDATA_PATH + path):
		for filepath in os.listdir(APPDATA_PATH + path):
			if "CustomAssetBundle" in filepath:
				with open(f'{APPDATA_PATH + path}/{filepath}', 'rb') as f:
					asset = Asset.from_file(f)
					print(f'{path}/{filepath}')
					container = asset.objects[1].contents['m_Container']
					for i in range(len(container)):
						print(f'\t {i} {container[i][0]}')