# An extension of backport.py to import voice lines for NPCs.
# Similar to backport.py, I made this utilize preset index ranges instead of dynamically searching for them. This just makes it easier once you've generated a list of every bundle's container objects.

import os
from unitypack.asset import Asset, ObjectPointer, FFOrderedDict, ObjectInfo

sourcefile = open('./CustomAssetBundle-DongResources_12_15', 'rb')
srcObjects = Asset.from_file(sourcefile).objects
srcContainer = srcObjects[1].contents['m_Container']
srcPreload = srcObjects[1].contents['m_PreloadTable']

APPDATA_PATH = (os.path.expandvars('%userprofile%')) + '/AppData/LocalLow/Unity/Web Player/Cache/FusionFall/'

targetfile = open(APPDATA_PATH + 'world_5fshared_5fpart1_2eresourceFile/CustomAssetBundle-eb037efed74f34db2b2bcdf47626cb76_old', 'rb')
data = Asset.from_file(targetfile)
objects = data.objects
container = objects[1].contents['m_Container']
preloads = objects[1].contents['m_PreloadTable']

for targetAssetNum in range(387,392):
	targetAssetName = srcContainer[targetAssetNum][0]
	targetAsset = srcContainer[targetAssetNum][1]

	preloadStart = targetAsset['preloadIndex']
	preloadNum = targetAsset['preloadSize']
	assetPointer = targetAsset['asset']

	assert preloadNum == 1

	assetContainerEntry = (targetAssetName, FFOrderedDict())
	assetContainerEntry[1]['preloadIndex'] = len(preloads) # Preload starts at wherever the array ends right now
	assetContainerEntry[1]['preloadSize'] = preloadNum # Load n assets

	preload = srcPreload[preloadStart]

	sourceObjectInfo = preload.object
	obj = data.add_object(sourceObjectInfo.type_id)
	obj._contents = sourceObjectInfo.contents 

	newPtr = ObjectPointer(None, data)	
	newPtr.file_id = 0
	newPtr.path_id = obj.path_id
	preloads.append(newPtr)

	assetContainerEntry[1]['asset'] = ObjectPointer(None, data)
	assetContainerEntry[1]['asset'].file_id = 0
	assetContainerEntry[1]['asset'].path_id = obj.path_id
	container.append(assetContainerEntry)

	print(targetAssetName)

tdatafile = open(APPDATA_PATH + 'tabledata_2eresourceFile/CustomAssetBundle-1dca92eecee4742d985b799d8226666d_old', 'rb')
tdataAsset = Asset.from_file(tdatafile)
tdata = tdataAsset.objects[7].contents
tdata['m_pNpcTable']['m_pNpcStringData'][3192]['m_strName'] = "Drew Saturday"
tdata['m_pNpcTable']['m_pNpcStringData'][3192]['m_strComment2'] = "Drew"
tdataout = open(APPDATA_PATH + 'tabledata_2eresourceFile/CustomAssetBundle-1dca92eecee4742d985b799d8226666d', 'wb')
tdataAsset.save(tdataout)

# outfile = open(APPDATA_PATH + 'world_5fshared_5fpart1_2eresourceFile/CustomAssetBundle-eb037efed74f34db2b2bcdf47626cb76', 'wb')
# data.save(outfile)